//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: AIPlayerReader
// Version: 1.0
// Last Modified: 17/02/2004
//----------------------------------------------------------------
import java.io.*;
import java.util.*;

public class AIPlayerReader{
	Player thePlayer;
public AIPlayerReader(Player thePlayerPar, String theFileStr){
	thePlayer = thePlayerPar;
	File aiPlayerFile = new File(theFileStr);
	Vector myTokens = new Vector();
	try{
	BufferedReader stream = new BufferedReader(new InputStreamReader(new FileInputStream(aiPlayerFile)));
	while (stream.ready()){
		String curStr = stream.readLine();
		StringTokenizer st = new StringTokenizer(curStr, ";");
		while (st.hasMoreTokens()){
			myTokens.addElement(st.nextToken());
		}
	}
	stream.close();
	}catch(Exception e){}
	Enumeration rules = myTokens.elements();
	try{
		String gamesPlayed = (String)rules.nextElement();
		setInsignificant((String)rules.nextElement());
		setRankSignificance((String)rules.nextElement());
		setAttackDecimal((String)rules.nextElement());
		setMinimumAttack((String)rules.nextElement());
		setMaximumAttack((String)rules.nextElement());
		setTypeNumMen((String)rules.nextElement());
		setReinforceRatio((String)rules.nextElement());
		setAttackEmpty((String)rules.nextElement());
		setDefendEmpty((String)rules.nextElement());
	//	setAttackTracking((String)rules.nextElement());
		System.out.println("Finished");
	}
	catch (Exception e){System.out.println(e.getMessage());}	
} 
private void setInsignificant(String insigPar){
	thePlayer.setInsignificant((new Float((String)insigPar.substring(14))).floatValue());
	System.out.println("INSIGNIFICANT "+thePlayer.getInsignificant()+";");
}

private void setRankSignificance(String rankSigPar){
	if (rankSigPar.substring(18).equals("TRUE")){
		thePlayer.setRankSignificance(true);
	}
	else{
		thePlayer.setRankSignificance(false);
	}	
	System.out.println("RANK_SIGNIFICANCE "+thePlayer.getRankSignificance()+";");	
}
private void setAttackDecimal(String adPar){
	if (!((String)adPar.substring(15)).equals("NULL")){
		thePlayer.setAttackDecimal((new Float((String)adPar.substring(15))).floatValue());
	}
	System.out.println("ATTACK_DECIMAL "+thePlayer.getAttackDecimal()+";");
}
private void setMinimumAttack(String minAttPar){
	thePlayer.setMinimumAttack((new Float((String)minAttPar.substring(15))).floatValue());
	System.out.println("MINIMUM_ATTACK "+thePlayer.getMinimumAttack()+";");
}
private void setMaximumAttack(String maxAttPar){
	thePlayer.setMaximumAttack((new Float((String)maxAttPar.substring(15))).floatValue());
	System.out.println("MAXIMUM_ATTACK "+thePlayer.getMaximumAttack()+";");
}
private void setTypeNumMen(String typeNumMenPar){
	String typeNumMen = typeNumMenPar.substring(13);
	if (typeNumMen.equals("MAX")) thePlayer.setTypeNumMen("MAX");
	else if (typeNumMen.equals("MIN")) thePlayer.setTypeNumMen("MIN");
	else if (typeNumMen.equals("AVERAGE"))thePlayer.setTypeNumMen("AVERAGE");
	else thePlayer.setTypeNumMen("RANDOM");
	System.out.println("TYPE_NUM_MEN "+thePlayer.getTypeNumMen()+";");
}
private void setReinforceRatio(String rrPar){
	thePlayer.setReinforceRatio((new Float((String)rrPar.substring(16))).floatValue());
	System.out.println("REINFORCE_RATIO "+thePlayer.getReinforceRatio()+";");
}
private void setAttackEmpty(String aePar){
	thePlayer.setAttackEmpty((new Float((String)aePar.substring(13))).floatValue());
	System.out.println("ATTACK_EMPTY "+thePlayer.getAttackEmpty()+";");
}
private void setDefendEmpty(String dePar){
	thePlayer.setDefendEmpty((new Float((String)dePar.substring(13))).floatValue());
	System.out.println("DEFEND_EMPTY "+thePlayer.getDefendEmpty()+";");
}
private void setAttackTracking(String atPar){
	if (((String)atPar.substring(16)).equals("TRUE")) thePlayer.setAttackTracking(true);
	else thePlayer.setAttackTracking(false);
	System.out.println("ATTACK_TRACKING "+thePlayer.getAttackTracking()+";");
}
}