//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: CustomPanelTest & IllegalNumException
// Version: 1.0
// Last Modified: 17/12/2003
//----------------------------------------------------------------
	 
// Java core packages
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

// Java extension packages
import javax.swing.*;

public class CustomPanelTest extends JFrame {
	static RiskGame theGame;
	static CustomPanel myPanel = new CustomPanel();
	static GameAutomater ga;
	static MouseAdapter mouseMoves;
   	static JMenuBar theMenu = new JMenuBar();
	static JMenu fileMenu = new JMenu();
	static JMenuItem loadGameRules = new JMenuItem();
	static JMenuItem loadGameStartState = new JMenuItem();
	static JPanel infoPanel = new JPanel();
	static JPanel actionPanel = new JPanel();
	static JPanel aiControlPanel = new JPanel();
	static JTextField noMen = new JTextField();
	static JLabel theCol = new JLabel("RED");
	static JLabel theCol2 = new JLabel("RED");
	static JButton move = new JButton("Move");
	static JButton defenderWD = new JButton("Defender Withdraw");
	static JButton attackerWD = new JButton("Attacker Withdraw");
	static JButton contButton = new JButton("Continue");
	static JButton aiButton = new JButton("Do Computer Move");
	static JButton startGameButton = new JButton("Start");
	static JButton doActionButton = new JButton("Do Action");
	static JLabel gameSpeedLabel = new JLabel("Game Speed:");
	static JComboBox gameSpeed = new JComboBox();
	static JLabel curPlayer = new JLabel("Turn:     ");
	static JLabel curSquare = new JLabel("Selected Square:    ");
	static JLabel redScore = new JLabel("Red Score:   ");
	static JLabel blueScore = new JLabel("Blue Score:   ");
	static JLabel winner = new JLabel("Winner:    ");
	static JLabel movesLeft = new JLabel("Moves Left:   ");
	static JLabel turnsRemain = new JLabel("Turns Remaining:   ");
	static boolean mlActive=false;
    static boolean gameStarted=false;
	static boolean bothAI=false;
	static boolean refreshView=true;
	static boolean gameFinished=false;
	static boolean isTourn=false;
	static boolean allMatchesPlayed=false;
	static boolean redUpdate=false;
	static boolean blueUpdate=false;
	static PrintStream gamesStats, newAIFile;
	static BufferedReader oldAIFile;
	static int battlesWonRed, battlesWonBlue, attWDRed, attWDBlue, defWDRed, defWDBlue, battleInitRed, battleInitBlue;
	static int alreadyOccSqsRed, alreadyOccSqsBlue, emptySqsRed, emptySqsBlue;
	static long menLostRed, menLostBlue, menGainedRed, menGainedBlue, menCommittedRed, menCommittedBlue;
	static ReinforcementPlayerReader rpr;

	// set up GUI
	public CustomPanelTest(int noGames, String gameRulesFile, String gamePositionsFile, String gameStatsFile, String tournFile, String aiUpdateFile){
		
		double curPos=0;
		boolean printedAIs=false;
		Vector matches = new Vector();
		refreshView=false;
		CustomPanelTest cpt = new CustomPanelTest();
		cpt.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE );
		try{
		gamesStats = new PrintStream( new FileOutputStream( new File (gameStatsFile)));
		gamesStats.println("<file="+gameStatsFile+">");
		gamesStats.println("<tournament_file="+tournFile+">");
		String tournLC = tournFile.toLowerCase();
		if (!tournLC.equals("null")){
			matches = loadTournamentFile(tournFile);
			isTourn=true;
		}
		String aiUpLC = aiUpdateFile.toLowerCase();
		int matchNum=0;
		while (!allMatchesPlayed){
			int gamesPlayed = 0;
			int gamesWonRed = 0;
			int gamesWonBlue = 0;
			int redSqsTot = 0;
			int blueSqsTot = 0;
			long redMenTot = 0;
			long blueMenTot = 0;
			long redPointsTot = 0;
			long bluePointsTot = 0;
			int totBattlesWonRed = 0;
			int totBattlesWonBlue = 0;
			long totMenLostRed = 0;
			long totMenLostBlue = 0;
			long totMenGainedRed = 0;
			long totMenGainedBlue = 0;
			int totAttWDRed = 0;
			int totAttWDBlue = 0;
			int totDefWDRed = 0;
			int totDefWDBlue = 0;
			long totMenCommittedRed = 0;
			long totMenCommittedBlue = 0;
			int totBattleInitRed = 0;
			int totBattleInitBlue = 0;
			int totAlreadyOccSqsRed = 0;
			int totAlreadyOccSqsBlue = 0;
			int totEmptySqsRed = 0;
			int totEmptySqsBlue = 0;
			RiskGameMatch curMatch = null;
			if (isTourn){
				curMatch = (RiskGameMatch)matches.get(matchNum);
				matchNum++;
				if (matchNum==matches.size()) allMatchesPlayed = true;
				gamesStats.println("<match_"+matchNum+">");
				gamesStats.println("<fixture="+curMatch.getRedPlayer()+","+curMatch.getBluePlayer()+">");
			}
			else allMatchesPlayed = true;
			gamesStats.println("<game_rules_file="+gameRulesFile+">");
			gamesStats.println("<game_positions_file="+gamePositionsFile+">");
			gamesStats.println("<no_games_played="+noGames+">");
			printedAIs=false;
			while (gamesPlayed<noGames){
				battlesWonRed=0;
				battlesWonBlue=0;
				menLostRed=0;
				menLostBlue=0;
				menGainedRed=0;
				menGainedBlue=0;
				attWDRed=0;
				attWDBlue=0;
				defWDRed=0;
				defWDBlue=0;
				menCommittedRed=0;
				menCommittedBlue=0;
				battleInitRed=0;
				battleInitBlue=0;
				alreadyOccSqsRed=0;
				alreadyOccSqsBlue=0;
				emptySqsRed=0;
				emptySqsBlue=0;
				curPos = 1;
				curPos = 2;
				loadGameRules.setEnabled(false);
				curPos = 3;
				loadGameStartState.setEnabled(false);
				curPos = 4;
				loadGameRulesExt(new File(gameRulesFile));
				curPos = 4.5;
				if (isTourn){
					System.out.println("getting new players");
					setRedPlayer("RED_PLAYER "+curMatch.getRedPlayer(),theGame);
					setBluePlayer("BLUE_PLAYER "+curMatch.getBluePlayer(),theGame);	
				}
				if (theGame.getRedPlayer().getType().equals(aiUpdateFile)) redUpdate=true;
				if (theGame.getBluePlayer().getType().equals(aiUpdateFile)) blueUpdate=true;
				curPos = 5;
				loadGameStartStateExt(new File(gamePositionsFile));
				if (!printedAIs){
					gamesStats.println("<red_player_type_file="+theGame.getRedPlayer().getType()+">");
					gamesStats.println("<blue_player_type_file="+theGame.getBluePlayer().getType()+">");
				//	gamesStats.println("<games>");
					printedAIs = true;
					
				}
				curPos = 6;
				disableAllButtons();
				curPos = 7;
				startGameButton.setEnabled(false);
				curPos = 8;
				gameSpeed.setEnabled(false);
				curPos = 9;
				createGameAutomater();
				curPos = 9.5;
				ga.setSpeed(0);
				curPos = 10;
				while (!gameFinished);
				curPos = 11;
				if (gameFinished){
					gamesPlayed++;
					gamesStats.println("<game_"+gamesPlayed+">");
					int redSqs = theGame.getRedSquares();
					redSqsTot += redSqs;
					int blueSqs = theGame.getBlueSquares();
					blueSqsTot+= blueSqs;
					long redMen = theGame.getRedMen();
					redMenTot += redMen;
					long blueMen = theGame.getBlueMen();
					blueMenTot += blueMen;
					long redPoints = theGame.getRedPoints();
					redPointsTot += redPoints;
					long bluePoints = theGame.getBluePoints();
					bluePointsTot += bluePoints;
					totBattlesWonRed += battlesWonRed;
					totBattlesWonBlue += battlesWonBlue;
					totMenLostRed += menLostRed;
					totMenLostBlue += menLostBlue;
					totMenGainedRed += menGainedRed;
					totMenGainedBlue += menGainedBlue;
					totAttWDRed += attWDRed;
					totAttWDBlue += attWDBlue;
					totDefWDRed += defWDRed;
					totDefWDBlue += defWDBlue;
					totMenCommittedRed += menCommittedRed;
					totMenCommittedBlue += menCommittedBlue;
					totBattleInitRed += battleInitRed;
					totBattleInitBlue += battleInitBlue;
					totAlreadyOccSqsRed += alreadyOccSqsRed;
					totAlreadyOccSqsBlue += alreadyOccSqsBlue;
					totEmptySqsRed += emptySqsRed;
					totEmptySqsBlue += emptySqsBlue;
					if (redPoints>bluePoints)gamesWonRed++;
					else if (redPoints<bluePoints)gamesWonBlue++;
					gamesStats.println("<red_points="+redPoints+"><blue_points="+bluePoints+">");
					gamesStats.println("<red_squares="+redSqs+"><blue_squares="+blueSqs+">");
					gamesStats.println("<red_men="+redMen+"><blue_men="+blueMen+">");
					gamesStats.println("<red_battles_won="+battlesWonRed+"><blue_battles_won="+battlesWonBlue+">");
					gamesStats.println("<red_men_lost="+menLostRed+"><blue_men_lost="+menLostBlue+">");
					gamesStats.println("<red_men_gained="+menGainedRed+"><blue_men_gained="+menGainedBlue+">");
					gamesStats.println("<red_attack_wd="+attWDRed+"><blue_attack_wd="+attWDBlue+">");
					gamesStats.println("<red_defend_wd="+defWDRed+"><blue_defend_wd="+defWDBlue+">");
					gamesStats.println("<red_men_committed="+menCommittedRed+"><blue_men_committed="+menCommittedBlue+">");
					gamesStats.println("<red_battles_init="+battleInitRed+"><blue_battles_init="+battleInitBlue+">");
					gamesStats.println("<red_move_occupied="+alreadyOccSqsRed+"><blue_move_occupied="+alreadyOccSqsBlue+">");
					gamesStats.println("<red_move_empty="+emptySqsRed+"><blue_move_empty="+emptySqsBlue+">");
					gamesStats.println("</game_"+gamesPlayed+">");
					curPos = 15;
					gameFinished=false;
					curPos = 16;
					curPos = 17;
				}
			}
			System.out.println("Red wins = "+gamesWonRed+", Blue wins = "+gamesWonBlue);
			gamesStats.println("<results>");
			gamesStats.println("<red_wins="+gamesWonRed+"><blue_wins="+gamesWonBlue+">");
			gamesStats.println("<red_points="+redPointsTot+"><blue_points="+bluePointsTot+">");
			gamesStats.println("<red_squares="+redSqsTot+"><blue_squares="+blueSqsTot+">");
			gamesStats.println("<red_men="+redMenTot+"><blue_men="+blueMenTot+">");	
			gamesStats.println("<red_battles_won="+totBattlesWonRed+"><blue_battles_won="+totBattlesWonBlue+">");	 
			gamesStats.println("<red_men_lost="+totMenLostRed+"><blue_men_lost="+totMenLostBlue+">");
			gamesStats.println("<red_men_gained="+totMenGainedRed+"><blue_men_gained="+totMenGainedBlue+">");
			gamesStats.println("<red_attack_wd="+totAttWDRed+"><blue_attack_wd="+totAttWDBlue+">");
			gamesStats.println("<red_defend_wd="+totDefWDRed+"><blue_defend_wd="+totDefWDBlue+">");
			gamesStats.println("<red_men_committed="+totMenCommittedRed+"><blue_men_committed="+totMenCommittedBlue+">");
			gamesStats.println("<red_battles_init="+totBattleInitRed+"><blue_battles_init="+totBattleInitBlue+">");
			gamesStats.println("<red_move_occupied="+totAlreadyOccSqsRed+"><blue_move_occupied="+totAlreadyOccSqsBlue+">");
			gamesStats.println("<red_move_empty="+totEmptySqsRed+"><blue_move_empty="+totEmptySqsBlue+">");
			gamesStats.println("</results>");
			if (isTourn) gamesStats.println("</match_"+matchNum+">");
			System.out.println("Now to update");
			if (redUpdate || blueUpdate){
				System.out.println("In update branch");
				rpr = new ReinforcementPlayerReader(aiUpdateFile);
				int totGames = rpr.getGamesPlayed();
				float insig = rpr.getInsignificant();
				boolean rankSig = rpr.getRankSignificance();
				float attDec = rpr.getAttackDecimal();
				float minAtt = rpr.getMinimumAttack();
				float maxAtt = rpr.getMaximumAttack();
				String typeNumMen = rpr.getTypeNumMen();
				float reinRat = rpr.getReinforceRatio();
				float attEmp = rpr.getAttackEmpty();
				float defEmp = rpr.getDefendEmpty();
				int gp = gamesWonRed+gamesWonBlue;
				int diffs[] = new int[13];
				diffs[0] = gamesWonRed-gamesWonBlue;
				diffs[1] = (new Long(redPointsTot-bluePointsTot)).intValue();
				diffs[2] = redSqsTot-blueSqsTot;
				diffs[3] = (new Long(redMenTot-blueMenTot)).intValue();
				diffs[4] = totBattlesWonRed-totBattlesWonBlue;
				diffs[5] = (new Long(totMenLostRed-totMenLostBlue)).intValue();
				diffs[6] = (new Long(totMenGainedRed-totMenGainedBlue)).intValue();
				diffs[7] = totAttWDRed-totAttWDBlue;
				diffs[8] = totDefWDRed-totDefWDBlue;
				diffs[9] = (new Long(totMenCommittedRed-totMenCommittedBlue)).intValue();
				diffs[10] = (new Long(totBattleInitRed-totBattleInitBlue)).intValue();
				diffs[11] = totAlreadyOccSqsRed-totAlreadyOccSqsBlue; 
				diffs[12] = totEmptySqsRed-totEmptySqsBlue;
				if (blueUpdate){
					for (int i=0; i<13; i++){
						diffs[i]= -diffs[i];
					}
				}
				float performW = diffs[0];
				performW = (-performW/gamesPlayed+1)/2;
				//performW = -performW;
				System.out.println("diffs[0] = "+diffs[0]);
				System.out.println("gamesPlayed = "+gamesPlayed);
				System.out.println("performW = "+performW);
				if (diffs[10]>diffs[4]) minAtt = (minAtt*(totGames+gamesPlayed*(1+performW)))/(totGames+gamesPlayed);
				else minAtt = (minAtt*(totGames+gamesPlayed*(1-performW)))/(totGames+gamesPlayed);
			/*	if (diffs[5]>0) maxAtt = (maxAtt*(totGames+gamesPlayed)+(1-maxAtt)*gamesPlayed*performW)/(totGames+gamesPlayed);
				else maxAtt = (maxAtt*(totGames+gamesPlayed)-maxAtt*gamesPlayed*performW)/(totGames+gamesPlayed);
				if (diffs[5]>diffs[6]) attDec = (attDec*(totGames+gamesPlayed)+(1-attDec)*gamesPlayed*performW)/(totGames+gamesPlayed);
				else attDec = (attDec*(totGames+gamesPlayed)-attDec*gamesPlayed*performW)/(totGames+gamesPlayed);*/
				Vector aiFile = new Vector();
				BufferedReader curAIFile = new BufferedReader(new InputStreamReader(new FileInputStream(aiUpdateFile)));
				while (curAIFile.ready()){
					aiFile.add(curAIFile.readLine());
				}
				curAIFile.close();
				newAIFile = new PrintStream( new FileOutputStream(new File(aiUpdateFile)));
				newAIFile.println("GAMES_PLAYED "+gamesPlayed+";");
				newAIFile.println("INSIGNIFICANT "+insig+";");
				if (rankSig) newAIFile.println("RANK_SIGNIFICANCE TRUE;");
				else newAIFile.println("RANK_SIGNIFICANCE FALSE;");
				newAIFile.println("ATTACK_DECIMAL "+attDec+";");
				newAIFile.println("MINIMUM_ATTACK "+minAtt+";");
				newAIFile.println("MAXIMUM_ATTACK "+maxAtt+";");
				newAIFile.println("TYPE_NUM_MEN "+typeNumMen+";");
				newAIFile.println("REINFORCE_RATIO "+reinRat+";");
				newAIFile.println("ATTACK_EMPTY "+attEmp+";");
				newAIFile.println("DEFEND_EMPTY "+defEmp+";");
				Enumeration enum1 = aiFile.elements();
				while (enum1.hasMoreElements()){
					newAIFile.println((String)enum1.nextElement());
				}
				newAIFile.close();
			}
			redUpdate=false;
			blueUpdate=false;
			gamesPlayed=0;
		}
		}catch (Exception e){ System.out.println("Got to curPos = "+curPos+" before error!");}		
		gamesStats.println("</file>");
		gamesStats.close();
		
	}

	public CustomPanelTest(){
   		super( "Risk Game" );	
		getContentPane().add( myPanel, BorderLayout.CENTER );
		noMen.setPreferredSize(new Dimension(50,20));
		theCol.setForeground(Color.RED);
		actionPanel.add(theCol);
		noMen.setEnabled(false);
		actionPanel.add(noMen);
		move.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				int noMenToMove = 0;
				if (theGame.getFromBox()!=null && theGame.getToBox()!=null){
					Box toBox = theGame.getGrid().getBox(theGame.getToBox());
					Box fromBox = theGame.getGrid().getBox(theGame.getFromBox());
					try{
						try{
							noMenToMove = Integer.parseInt(noMen.getText());
						}
						catch (Exception e){ throw new IllegalNumException("You have not entered a valid number!");}
						if (theGame.getTurn()==Box.RED){
							if (noMenToMove>0 && noMenToMove<=fromBox.getRedNum()){
								if (toBox.getRedNum()==0) theGame.getRedPlayer().addSquare(toBox);
								toBox.setRedNum(toBox.getRedNum()+noMenToMove);
								fromBox.setRedNum(fromBox.getRedNum()-noMenToMove);
								if (fromBox.getRedNum()<=0) theGame.getRedPlayer().removeSquare(fromBox.getBoxPosition());
							}
							else throw new IllegalNumException("You must move at least one man but you cannot move any more than the number of men in the square you are moving men from!");
						}
						else if (theGame.getTurn()==Box.BLUE){
							if (noMenToMove>0 && noMenToMove<=fromBox.getBlueNum()){
								if (toBox.getBlueNum()==0) theGame.getBluePlayer().addSquare(toBox);
								toBox.setBlueNum(toBox.getBlueNum()+noMenToMove);
								fromBox.setBlueNum(fromBox.getBlueNum()-noMenToMove);
								if (fromBox.getBlueNum()<=0) theGame.getBluePlayer().removeSquare(fromBox.getBoxPosition());
							}
							else throw new IllegalNumException("You must move at least one man but you cannot move any more than the number of men in the square you are moving men from!");
						}
						theGame.tidyBox(toBox.getBoxPosition());
						theGame.tidyBox(fromBox.getBoxPosition());
						if (toBox.getCol()==Box.BOTH){
							theGame.setBattleInProgress(true);
							theGame.setBattleBox(toBox.getBoxPosition());
							startBattle();
						}
						else{
							finishedBattle();
						}
					}
					catch (IllegalNumException ine){System.out.println(ine.getMessage());}
				}
				else{
					System.out.println("You have not chosen where to move men to or from!");
				}
				if (theGame!=null){
					myPanel.repaint();
					updateInfoBar();
				}
			}			
		});
		move.setEnabled(false);
		actionPanel.add(move);
		defenderWD.setEnabled(false);
		defenderWD.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				int defCol=0;
				if (theGame.getTurn()==Box.RED) defCol=Box.BLUE;
				else defCol=Box.RED;
				if (theGame.getWithdraws(theGame.getGrid().getBox(theGame.getBattleBox()),defCol).size()>0){
					if (!mlActive)myPanel.addMouseListener(mouseMoves);
					mlActive=true;
					contButton.setEnabled(false);
					defenderWD.setEnabled(false);
					attackerWD.setEnabled(false);
					move.setEnabled(false);
					noMen.setEnabled(false);
					theGame.setDefWDing(true);
					updateInfoBar();
				}
				else JOptionPane.showMessageDialog(myPanel,  "There is no square to withdraw to.", "ERROR", JOptionPane.INFORMATION_MESSAGE);
			}

		});	
		actionPanel.add(defenderWD);
		attackerWD.setEnabled(false);
		attackerWD.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (theGame.getWithdraws(theGame.getGrid().getBox(theGame.getBattleBox()),theGame.getTurn()).size()>0){
					if (!mlActive)myPanel.addMouseListener(mouseMoves);
					mlActive=true;
					contButton.setEnabled(false);
					defenderWD.setEnabled(false);
					attackerWD.setEnabled(false);
					move.setEnabled(false);
					noMen.setEnabled(false);
					theGame.setAttWDing(true);
					updateInfoBar();
				}
				else JOptionPane.showMessageDialog(myPanel,  "There is no square to withdraw to.", "ERROR", JOptionPane.INFORMATION_MESSAGE);
			}
		});
		actionPanel.add(attackerWD);
		contButton.setEnabled(false);
		contButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				startBattle();
				if (theGame!=null){
					myPanel.repaint();
					updateInfoBar();
				}
			}
		});
		actionPanel.add(contButton);
		aiButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
			    try{
					theGame.getPlayer(theGame.getTurn()).createPlayerMoveGenerator(theGame.getGridX(), theGame.getGridY(), theGame.getDiagonalSquaresAdjacent());
					long playerMen = theGame.getMen(theGame.getTurn());
					long oppMen = 0; 
					Vector oppMenVec = new Vector();
					if (theGame.getTurn()==Box.RED){
						oppMen = theGame.getBlueMen();
						oppMenVec = theGame.getSquaresVec(Box.RED);
					}
					else{
						oppMen = theGame.getRedMen();
						oppMenVec = theGame.getSquaresVec(Box.BLUE);
					}
					float tot = oppMen+playerMen;
					float pmFloat = playerMen;
					float result = pmFloat/tot;
				//	System.out.println("playerMen = "+playerMen+", oppMen = "+oppMen+", playerMen/(oppMen+playerMen) = "+result);
					RiskGameMove curMove = theGame.getPlayer(theGame.getTurn()).generateMove(result,theGame.getGrid(),new Vector(oppMenVec));
					theGame.setToBox(curMove.getToBox());
					theGame.setFromBox(curMove.getFromBox());
					Long aLong = new Long(theGame.getGrid().getBox(theGame.getFromBox()).getNum(theGame.getTurn())-curMove.getNoMen());
					if (aLong.intValue()<=0) theGame.getPlayer(theGame.getTurn()).removeSquare(theGame.getGrid().getBox(theGame.getFromBox()).getBoxPosition());
					theGame.getGrid().getBox(theGame.getFromBox()).setNum(theGame.getTurn(),aLong.intValue());
					aLong = new Long(theGame.getGrid().getBox(theGame.getToBox()).getNum(theGame.getTurn())+curMove.getNoMen()); 
					if (aLong.intValue()-curMove.getNoMen()==0) theGame.getPlayer(theGame.getTurn()).addSquare(theGame.getGrid().getBox(theGame.getToBox())); 
					theGame.getGrid().getBox(theGame.getToBox()).setNum(theGame.getTurn(),aLong.intValue());
					theGame.tidyBox(theGame.getFromBox());
					theGame.tidyBox(theGame.getToBox());
					System.out.println("fromBox = "+ theGame.getFromBox().getHoriz()+", "+theGame.getFromBox().getVert()+".");
					System.out.println("noMen = "+curMove.getNoMen());
					System.out.println("toBox = "+ theGame.getToBox().getHoriz()+", "+theGame.getToBox().getVert()+"."); 
					if (theGame.getGrid().getBox(theGame.getToBox()).getCol()==Box.BOTH){
						theGame.setBattleInProgress(true);
						theGame.setBattleBox(theGame.getToBox());
				 		startBattle();
					}
					else finishedBattle();
					if (theGame!=null){
						myPanel.repaint();
						updateInfoBar();
					}
				}
				catch (Exception e){ 
					try{
				   		System.out.println("toBox = "+ theGame.getToBox().getHoriz()+", "+theGame.getToBox().getVert()+"."); 
					}
					catch (Exception e2){System.out.println("Problem with toBox");}
				}
			}
		});	
		actionPanel.add(aiButton);
		aiButton.setEnabled(false);
		startGameButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent ae){
				if (gameStarted){
					ga.stopThread();
					gameStarted = false;
					startGameButton.setText("Start");
					doActionButton.setEnabled(true);
				}
				else{
					int gameSpeedPar = 500;
					if((gameSpeed.getSelectedItem()).equals("Very Slow")) gameSpeedPar = 1000;
					else if ((gameSpeed.getSelectedItem()).equals("Slow")) gameSpeedPar = 500;
					else if ((gameSpeed.getSelectedItem()).equals("Normal")) gameSpeedPar = 250;
					else if ((gameSpeed.getSelectedItem()).equals("Fast")) gameSpeedPar = 100;
					else if ((gameSpeed.getSelectedItem()).equals("Very Fast")) gameSpeedPar = 50;
					ga = new GameAutomater(theGame,myPanel,gameSpeedPar);
				//	if (!mlActive)myPanel.addMouseListener(mouseMoves);
				//	mlActive=true;	
					ga.start();
					gameStarted = true;
					startGameButton.setText("Stop");
					doActionButton.setEnabled(false);
				}
				//startGameButton.setEnabled(false);
			}
		});			
	//	actionPanel.add(startGameButton);
		startGameButton.setEnabled(false);
	//	startGameButton.setEnabled(true);
		theCol.setForeground(Color.RED);
		aiControlPanel.add(theCol2);
		aiControlPanel.add(gameSpeedLabel);
		gameSpeed.setMaximumRowCount(5);
		gameSpeed.addItem("Very Slow");
		gameSpeed.addItem("Slow");
		gameSpeed.addItem("Normal");
		gameSpeed.addItem("Fast");
		gameSpeed.addItem("Very Fast");
		gameSpeed.setSelectedIndex(1);
		gameSpeed.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				if((gameSpeed.getSelectedItem()).equals("Very Slow")){
					ga.setSpeed(1000);
				}
				else if ((gameSpeed.getSelectedItem()).equals("Slow")){
					ga.setSpeed(500);
				}
				else if ((gameSpeed.getSelectedItem()).equals("Normal")){
					ga.setSpeed(250);
				}
				else if ((gameSpeed.getSelectedItem()).equals("Fast")){
					ga.setSpeed(100);
				}
				else if ((gameSpeed.getSelectedItem()).equals("Very Fast")){
					ga.setSpeed(50);
				}
			}
		});
		gameSpeed.setEnabled(false);
		doActionButton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				ga.doAction();
			}
		});
		doActionButton.setEnabled(false);
		aiControlPanel.add(gameSpeed);
		aiControlPanel.add(startGameButton);
		aiControlPanel.add(doActionButton);
		getContentPane().add( actionPanel, BorderLayout.SOUTH );
		infoPanel.add(curPlayer);
		infoPanel.add(curSquare);
	//	infoPanel.add(curSquareCol);
		infoPanel.add(redScore);
		infoPanel.add(blueScore);
		infoPanel.add(winner);
		infoPanel.add(movesLeft);
		infoPanel.add(turnsRemain);
		getContentPane().add( infoPanel, BorderLayout.NORTH );
		setJMenuBar(theMenu);
		loadGameRules.setText("Load Game Rules");
		loadGameRules.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				loadGameRules();
				if ((!theGame.getRedPlayer().getType().equals("HUMAN")) && (!theGame.getRedPlayer().getType().equals("HUMAN"))){
					getContentPane().remove( actionPanel );
					getContentPane().add( aiControlPanel, BorderLayout.SOUTH );
					setVisible(false);
					setVisible(true);
					bothAI=true;
				}
				else{
					getContentPane().remove( aiControlPanel );
					getContentPane().add( actionPanel, BorderLayout.SOUTH );
					setVisible(false);
					setVisible(true);
					bothAI=false;
				}
				updateInfoBar();
				myPanel.repaint();
			}	 
		});
		loadGameStartState.setText("Load Game Start State");
		loadGameStartState.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				loadGameStartState();
				updateInfoBar();
				myPanel.repaint();
				if ((!theGame.getRedPlayer().getType().equals("HUMAN")) && (!theGame.getRedPlayer().getType().equals("HUMAN"))){
					aiButton.setEnabled(false);
					contButton.setEnabled(false);
					attackerWD.setEnabled(false);
					defenderWD.setEnabled(false);
					move.setEnabled(false);
					noMen.setEnabled(false);
					createGameAutomater();
					startGameButton.setEnabled(true);
					gameSpeed.setEnabled(true);
					gameSpeed.setSelectedIndex(1);
				}
				else if (!theGame.getPlayer(Box.RED).getType().equals("HUMAN")){
					aiButton.setEnabled(true);
					contButton.setEnabled(false);
					attackerWD.setEnabled(false);
					defenderWD.setEnabled(false);
					move.setEnabled(false);
					noMen.setEnabled(false);
				}
			}
		});	
		fileMenu.add(loadGameRules);
		fileMenu.add(loadGameStartState);
		fileMenu.setText("File");
		loadGameStartState.setEnabled(false);
		theMenu.add(fileMenu);	
      	setSize( 800, 600 );
      	setVisible( true );
   	}
	private static void setRedPlayer(String playerTypePar, RiskGame theGamePar){
		String rpType = playerTypePar.substring(11);
		theGamePar.getRedPlayer().setType(rpType);	
		if (!(rpType.equals("HUMAN") || rpType.equals("AI_PLAYER"))){
			AIPlayerReader aipr = new AIPlayerReader(theGamePar.getRedPlayer(),rpType);
		}
		System.out.println("Red player = "+	theGamePar.getRedPlayer().getType()+";");
	}
	private static void setBluePlayer(String playerTypePar, RiskGame theGamePar){
		String bpType = playerTypePar.substring(12);
		theGamePar.getBluePlayer().setType(bpType);	
		if (!(bpType.equals("HUMAN") || bpType.equals("AI_PLAYER"))){
			AIPlayerReader aipr = new AIPlayerReader(theGamePar.getBluePlayer(),bpType);
		}
		System.out.println("Blue player = "+	theGamePar.getBluePlayer().getType()+";");
	}
	public static void finishedGame(){
		if((!theGame.getRedPlayer().getType().equals("HUMAN")) && (!theGame.getBluePlayer().getType().equals("HUMAN"))) ga.stopThread();
		if (refreshView){
			int redSqs = theGame.getRedSquares();
			int blueSqs = theGame.getBlueSquares();
			long redMen = theGame.getRedMen();
			long blueMen = theGame.getBlueMen();
			long redPoints = theGame.getRedPoints();
			long bluePoints = theGame.getBluePoints();
			if (redPoints>bluePoints)
				JOptionPane.showMessageDialog(myPanel,  "Red beats Blue by "+redPoints+" to "+bluePoints+".\nRed has "+redMen+" men left and Blue has "+blueMen+" men left.\nRed occupies "+redSqs+" squares and Blue occupies "+blueSqs+" squares.", "And the winner is...", JOptionPane.INFORMATION_MESSAGE);
			else if (redPoints<bluePoints)
				JOptionPane.showMessageDialog(myPanel, "Blue beats Red by "+bluePoints+" to "+redPoints+".\nRed has "+redMen+" men left and Blue has "+blueMen+" men left.\nRed occupies "+redSqs+" squares and Blue occupies "+blueSqs+" squares.", "And the winner is...", JOptionPane.INFORMATION_MESSAGE);
			else 
				JOptionPane.showMessageDialog(myPanel, "Its a tie "+bluePoints+"-"+redPoints+".\nRed has "+redMen+" men left and Blue has "+blueMen+" men left.\nRed occupies "+redSqs+" squares and Blue occupies "+blueSqs+" squares.", "And the winner is...", JOptionPane.INFORMATION_MESSAGE);	
		}
		else gameFinished=true;
	}

	private void createGameAutomater(){
	    //try{
			ga = new GameAutomater(theGame, myPanel, 500);
			if (!refreshView){
				ga.start();
				gameStarted=true;
			}
			else{
				doActionButton.setEnabled(true);
			}
			startGameButton.setEnabled(true);
			
		//}
		//catch (Exception e){ System.out.println("Error in createGameAutomater at curPlace = "+curPlace);}
	}
   // execute application
   public static void main( String args[] ){
   		if (args.length==0){
			CustomPanelTest application = new CustomPanelTest();
			application.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE );	
		}
		else if (args.length==6){
			try{
				CustomPanelTest application = new CustomPanelTest((new Integer((String)args[0])).intValue(),(String)args[1], (String)args[2], (String)args[3], (String)args[4], (String)args[5]);
				application.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE );
			}
			catch (Exception e){ System.out.println("Error with command line arguments!");}
		}	
   }	
   	private void loadGameRules(){
		File file = null;
		JFileChooser gameRulesLoader = new JFileChooser();
		gameRulesLoader.addChoosableFileFilter(new RiskGameRulesFileFilter());
		int answer = gameRulesLoader.showOpenDialog(CustomPanelTest.this);
		if (answer == JFileChooser.APPROVE_OPTION){
			file = gameRulesLoader.getSelectedFile();
			loadGameRulesExt(file);
		}
	}
	private void loadGameRulesExt(File file){
		try{
			doActionButton.setEnabled(false);
			myPanel = new CustomPanel();
			RiskGameReader rgr = new RiskGameReader(file);
			theGame = rgr.getRiskGame();
			myPanel.setGame(theGame);
			myPanel.setBackground(Color.GREEN);
			myPanel.addMouseListener(mouseMoves = new MouseAdapter(){	
	  			public void mousePressed(MouseEvent event){
					if (!theGame.getBattleInProgress()){
						if (event.getButton()==MouseEvent.BUTTON1){
							System.out.println("X = "+event.getX()+"; Y = "+event.getY()+";");
							myPanel.handleClick(event.getX(), event.getY());
							//System.out.println("CurBox: H = "+theGame.getCurBox().getHoriz()+"; V = "+theGame.getCurBox().getVert());
						}
						else{
							theGame.setCurBox(null);
							theGame.setFromBox(null);
							theGame.setToBox(null);
							move.setEnabled(false);
							noMen.setEnabled(false);
						}
						if (theGame.getToBox()!=null){
							move.setEnabled(true);
							noMen.setEnabled(true);
						}
						else{
							move.setEnabled(false);
							noMen.setEnabled(false);
							noMen.setText("");
						}
						myPanel.repaint();
						updateInfoBar();
					}
					else if (theGame.getDefWDing()||theGame.getAttWDing()){	
						if (event.getButton()==MouseEvent.BUTTON1){
							myPanel.handleClick(event.getX(), event.getY());
							if (myPanel.getRetreatAllowed()){
								finishedBattle();
							}
						}
					}
				}
	 		});
			mlActive=true;
			getContentPane().add( myPanel, BorderLayout.CENTER ); 
			if (theGame.getSquareAllocStatus()==RiskGame.FROM_FILE || theGame.getManAllocStatus()==RiskGame.FROM_FILE){
				loadGameStartState.setEnabled(true);
			}
			theGame.setGameState(RiskGame.SQUARE_SELECT);
		}
		catch (Exception e) {
			System.out.println("Exception");
		}
	}
		
	private void loadGameStartState(){
		File file = null;
		JFileChooser gamePositionsLoader = new JFileChooser();
		gamePositionsLoader.addChoosableFileFilter(new RiskGamePositionsFileFilter());
		int answer = gamePositionsLoader.showOpenDialog(CustomPanelTest.this);
		if (answer == JFileChooser.APPROVE_OPTION){
			file = gamePositionsLoader.getSelectedFile();
			loadGameStartStateExt(file);
		}
		else if(!theGame.getRedPlayer().getType().equals("HUMAN")){
			if (mlActive) myPanel.removeMouseListener(mouseMoves);
			mlActive=false;
		}	
	}
	private void loadGameStartStateExt(File file){
		try {
			PositionReader pr = new PositionReader(file, theGame);
			theGame.setGameState(RiskGame.IN_GAME);
			updateInfoBar();
		}
		catch (IOException ioe){System.err.println("Error creating PositionReader");}
	}
	private static Vector loadTournamentFile(String fileStr){
		Vector matches = new Vector();
		try{
			TournamentReader tr = new TournamentReader(fileStr);
			matches = tr.getMatches();
		}
		catch(Exception e){}
		return matches;
	}	
	public static boolean getMLActive(){
		return mlActive;
	}
	public static void setMLActive(boolean mlActivePar){
		mlActive = mlActivePar;
	}
	public static boolean getRefreshView(){
		return refreshView;
	}
	public static void addBattleWon(int colPar){
		if (colPar==Box.RED) battlesWonRed++;
		else battlesWonBlue++;
	}
	public static void addMenLost(int colPar, long noMenPar){
		if (colPar==Box.RED) menLostRed += noMenPar;
		else menLostBlue += noMenPar;
	}
	public static void addMenGained(int colPar, long noMenPar){
		if (colPar==Box.RED) menGainedRed += noMenPar;
		else menGainedBlue += noMenPar;
	}
	public static void addAttackingWD(int colPar){
		if (colPar==Box.RED) attWDRed++;
		else attWDBlue++;
	}
	public static void addDefensiveWD(int colPar){
		if (colPar==Box.RED) defWDRed++;
		else defWDBlue++;
	}
	public static void addMenCommitted(int colPar, long noMenPar){
		if (colPar==Box.RED) menCommittedRed += noMenPar;
		else menCommittedBlue += noMenPar;
	}
	public static void addBattleInit(int colPar){
		if (colPar==Box.RED) battleInitRed++;
		else battleInitBlue++;
	}
	public static void addToAlreadyOccSqs(int colPar){
		if (colPar==Box.RED) alreadyOccSqsRed++;
		else alreadyOccSqsBlue++;
	}
	public static void addToEmptySqs(int colPar){
		if (colPar==Box.RED) emptySqsRed++;
		else emptySqsBlue++;
	}
	public static void setColour(){
		if (theGame.getTurn()==Box.RED){
			theCol.setText("RED");
			theCol.setForeground(Color.RED);
			theCol2.setText("RED");
			theCol2.setForeground(Color.RED);
		}
		else{
			theCol.setText("BLUE");
			theCol.setForeground(Color.BLUE);
			theCol2.setText("BLUE");
			theCol2.setForeground(Color.BLUE);
		}
	}
	private void startBattle(){
		if (mlActive) myPanel.removeMouseListener(mouseMoves);	
		mlActive=false;
		if (theGame.getTurn()==Box.RED){
			if (theGame.getRedPlayer().getType().equals("HUMAN")){
		//		System.out.println("Its Reds turn, he is Human and attackerWD = "+theGame.getAttackerWithdraw());
				attackerWD.setEnabled(theGame.getAttackerWithdraw());
			}
			else attackerWD.setEnabled(false);
			if (theGame.getBluePlayer().getType().equals("HUMAN")){
		//		System.out.println("Its Reds turn, blue is Human and defenderWD = "+theGame.getDefenderWithdraw());
				defenderWD.setEnabled(theGame.getDefenderWithdraw());
			}
			else defenderWD.setEnabled(false);
		}
		else{
			if (theGame.getBluePlayer().getType().equals("HUMAN")){
		//		System.out.println("Its blues turn, he is Human and AttackerWD = "+theGame.getAttackerWithdraw());
				attackerWD.setEnabled(theGame.getAttackerWithdraw());

			}
			else attackerWD.setEnabled(false);
			if (theGame.getRedPlayer().getType().equals("HUMAN")){
		//		System.out.println("Its blues turn, red is Human and defenderWD = "+theGame.getDefenderWithdraw());
				defenderWD.setEnabled(theGame.getDefenderWithdraw());
			}
			else defenderWD.setEnabled(false);
		}				
		if (!theGame.getPlayer(theGame.getTurn()).equals("HUMAN"))aiButton.setEnabled(false);	
		move.setEnabled(false);
		noMen.setEnabled(false);
		contButton.setEnabled(true);
		Box battleBox = theGame.getGrid().getBox(theGame.getBattleBox());
		long scoreMax = theGame.getScoreMax(battleBox);
		long redScore = Math.round(Math.random()*scoreMax);
		long blueScore = Math.round(Math.random()*scoreMax);
		if (theGame.getWeighted()){
			redScore = redScore*battleBox.getRedNum();
			blueScore = blueScore*battleBox.getBlueNum();
		}
		if (redScore==blueScore && theGame.getDraws()==RiskGame.REROLLED){
			while (redScore==blueScore){
				redScore = Math.round(Math.random()*scoreMax);
				blueScore = Math.round(Math.random()*scoreMax);
				if (theGame.getWeighted()){
					redScore = redScore*battleBox.getRedNum();
					blueScore = blueScore*battleBox.getBlueNum();
				}
			}
		}
		if (theGame.getScoreResultStatus()==RiskGame.BATTLE){
			if (redScore>blueScore ||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS && theGame.getGameState()==RiskGame.IN_GAME)||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS)){
				battleBox.setBlueNum(0);
				theGame.setLastWinner(Box.RED);
			}
			else if (redScore<blueScore ||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS)||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS && theGame.getGameState()==RiskGame.IN_GAME)){
				battleBox.setRedNum(0);
				theGame.setLastWinner(Box.BLUE);
			}
			finishedBattle();
		}
		else if (theGame.getScoreResultStatus()==RiskGame.ONE_MAN){
			if (redScore>blueScore ||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS && theGame.getGameState()==RiskGame.IN_GAME)||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS)){
				battleBox.setBlueNum(battleBox.getBlueNum()-1);
				theGame.setLastWinner(Box.RED);
			}
			else if (redScore<blueScore ||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS)||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS && theGame.getGameState()==RiskGame.IN_GAME)){
				battleBox.setRedNum(battleBox.getRedNum()-1);
				theGame.setLastWinner(Box.BLUE);
			}
			if (battleBox.getRedNum()==0 || battleBox.getBlueNum()==0){
				finishedBattle();
			}
		}
		if (theGame!=null){
			updateInfoBar();
			theGame.setLastRedScore(redScore);
			theGame.setLastBlueScore(blueScore);
			if (theGame.getBattleBox()!=null){
				if (theGame.getAttackerWithdraw()){
					if ((!theGame.getPlayer(theGame.getTurn()).equals("HUMAN")) && theGame.getPlayer(theGame.getTurn()).getShouldWithdraw(battleBox.getRedNum(),battleBox.getBlueNum())){
						theGame.setAttWDing(true);
						myPanel.doWithdraw(theGame.getPlayer(theGame.getTurn()).getWithdraw(theGame.getWithdraws(battleBox,theGame.getTurn())));
						if (myPanel.getRetreatAllowed()) finishedBattle();
					}
				}	
				if (theGame!=null){
					if (theGame.getBattleBox()!=null){
						if (theGame.getDefenderWithdraw()){
							if ((!theGame.getPlayer(Box.RED).equals("HUMAN")) && theGame.getTurn()==Box.BLUE && theGame.getPlayer(Box.RED).getShouldWithdraw(battleBox.getRedNum(),battleBox.getBlueNum())){
								theGame.setDefWDing(true);
								myPanel.doWithdraw(theGame.getPlayer(Box.RED).getWithdraw(theGame.getWithdraws(battleBox,Box.RED)));
								if (myPanel.getRetreatAllowed()) finishedBattle();
							}
							if (theGame!=null){
								if ((!theGame.getPlayer(Box.BLUE).equals("HUMAN")) && theGame.getTurn()==Box.RED && theGame.getPlayer(Box.BLUE).getShouldWithdraw(battleBox.getRedNum(),battleBox.getBlueNum())){
									theGame.setDefWDing(true);
									myPanel.doWithdraw(theGame.getPlayer(Box.BLUE).getWithdraw(theGame.getWithdraws(battleBox,Box.BLUE)));	
									if (myPanel.getRetreatAllowed()) finishedBattle();
								}
							}	
						}	
					}
				}
			}
		}
	}
		
	public static void updateInfoBar(){
	if (refreshView){
		if (theGame.getTurn()==Box.RED)
			curPlayer.setText("Turn: RED. ");
		else
			curPlayer.setText("Turn: BLUE. ");
		if (theGame.getCurBox()==null)
			curSquare.setText("Selected Square: NONE. ");
		else
			curSquare.setText("Selected Square: "+theGame.getCurBox().getHoriz()+"x"+theGame.getCurBox().getVert()+"."); 
		redScore.setText("Red Score: "+theGame.getLastRedScore()+". ");
		blueScore.setText("Blue Score: "+theGame.getLastBlueScore()+". ");
		if (theGame.getLastWinner()==Box.RED)
			winner.setText("Winner: RED. ");
		else if (theGame.getLastWinner()==Box.BLUE)
			winner.setText("Winner: BLUE. ");
		else
			winner.setText("Winner: NONE. ");
		movesLeft.setText("Moves Left: "+theGame.getMovesLeft()+". ");
		if (theGame.getNoTurns()==0){
			turnsRemain.setText("Turns Remaining: n/a. ");
		}
		else turnsRemain.setText("Turns Remaining: "+theGame.getTurnsRemain()+". ");
		}
	}
	public void finishedBattle(){
		theGame.setBattleInProgress(false);
		contButton.setEnabled(false);
		noMen.setText("");
		move.setEnabled(false);
		noMen.setEnabled(false);
		defenderWD.setEnabled(false);
		attackerWD.setEnabled(false);
		if (theGame.getBattleBox()!=null){
			if (theGame.getGrid().getBox(theGame.getBattleBox()).getRedNum()<=0)
				theGame.getRedPlayer().removeSquare(theGame.getBattleBox());
			if (theGame.getGrid().getBox(theGame.getBattleBox()).getBlueNum()<=0)
				theGame.getBluePlayer().removeSquare(theGame.getBattleBox());
		}
		if (theGame.getFromBox()!=null)theGame.tidyBox(theGame.getFromBox());
		if (theGame.getToBox()!=null)theGame.tidyBox(theGame.getToBox());
		if (theGame.getCurBox()!=null)theGame.tidyBox(theGame.getCurBox());
		theGame.setCurBox(null);
		theGame.setFromBox(null);
		theGame.setToBox(null);
		theGame.setBattleBox(null);
		theGame.decrementMovesLeft();
		setColour();
		updateInfoBar();
		myPanel.repaint();
		if (theGame.getMovesLeft()==0){
			theGame.resetMovesLeft();
			theGame.swapTurns();
		}
		if (theGame.getPlayer(theGame.getTurn()).getType().equals("HUMAN")){
		//	System.out.println("This is a human player");
			if (!mlActive)myPanel.addMouseListener(mouseMoves);
			mlActive=true;
		}
		setColour();
		if (!theGame.getPlayer(theGame.getTurn()).getType().equals("HUMAN")){
			aiButton.setEnabled(true);
			contButton.setEnabled(false);
			attackerWD.setEnabled(false);
			defenderWD.setEnabled(false);
			move.setEnabled(false);
			noMen.setEnabled(false);
		}
		else{
			aiButton.setEnabled(false);
		}
		if (theGame.getRedPlayer().getNoOccupiedSquares()==0 || theGame.getBluePlayer().getNoOccupiedSquares()==0){
			theGame.setGameFinished();
		}
		boolean gameFinished = theGame.getGameFinished();
		if (gameFinished){
			int curpos = 0;
			try{
				finishedGame();	
				disableAllButtons();
				gameSpeed.setEnabled(false);
				startGameButton.setEnabled(false);
				doActionButton.setEnabled(false);
				if((!theGame.getRedPlayer().getType().equals("HUMAN")) && (!theGame.getBluePlayer().getType().equals("HUMAN"))) ga.stopThread();
				myPanel.setGame(null);
				myPanel=new CustomPanel();
				theGame=null;
				myPanel.repaint();
				resetPanel();
				getContentPane().remove(actionPanel);
				getContentPane().remove(aiControlPanel);
				setVisible(false);
				setVisible(true);
				getContentPane().add(actionPanel, BorderLayout.SOUTH);

			}
			catch (Exception e){}
		}
	}
	public static void resetPanel(){
		theCol.setForeground(Color.RED);
		theCol.setText("RED");
		theCol2.setForeground(Color.RED);
		theCol2.setText("RED");
		theCol.setForeground(Color.RED);
		curPlayer.setText("Turn:     ");
		curSquare.setText("Selected Square:    ");
		redScore.setText("Red Score:   ");
		blueScore.setText("Blue Score:   ");
		winner.setText("Winner:    ");
		movesLeft.setText("Moves Left:   ");
		turnsRemain.setText("Turns Remaining:   ");
		loadGameStartState.setEnabled(false);
		gameSpeed.setEnabled(false);
		doActionButton.setEnabled(false);
		startGameButton.setEnabled(false);
	}
	public static void disableAllButtons(){
		aiButton.setEnabled(false);
		contButton.setEnabled(false);
		noMen.setEnabled(false);
		move.setEnabled(false);
		defenderWD.setEnabled(false);
		attackerWD.setEnabled(false);
	//	doActionButton.setEnabled(false);
		if (mlActive){ myPanel.removeMouseListener(mouseMoves);}
		mlActive=false;
	}
}		
	
class IllegalNumException extends Exception{
	public IllegalNumException(){
		super();
	}
	public IllegalNumException(String message){
		super(message);
	}
}