import java.util.*;
public class GameAutomater extends Thread{
	private RiskGame theGame;
	private CustomPanel myPanel;
	private boolean stopped = false;
	private int sleepTime = 500;
	
	public GameAutomater(RiskGame theGamePar, CustomPanel myPanelPar, int sleepTimePar){
		theGame = theGamePar;
		myPanel = myPanelPar;
		sleepTime = sleepTimePar;
	}

	public void run(){
		try{
			while (!theGame.getGameFinished() && (!stopped)){
				doAction();
				sleep(sleepTime);	
			}
		}
		catch (Exception e){ System.out.println("Error in GameAutomater");}
	}					

	public void stopThread() {
		stopped = true;
	}		
	public void setSpeed(int sleepTimePar){
		sleepTime = sleepTimePar;
	}
	public void doAction(){
		CustomPanelTest.disableAllButtons();
		if (theGame!=null){
			if (theGame.getBattleBox()!=null){
				startBattle();
				if (theGame!=null){
					myPanel.repaint();
					CustomPanelTest.updateInfoBar();
				}
			}
			else if (!(theGame.getRedPlayer().getNoOccupiedSquares()==0 || theGame.getBluePlayer().getNoOccupiedSquares()==0)){
				theGame.getPlayer(theGame.getTurn()).createPlayerMoveGenerator(theGame.getGridX(), theGame.getGridY(), theGame.getDiagonalSquaresAdjacent());
				long playerMen = theGame.getMen(theGame.getTurn());
				long oppMen = 0; 
				Vector oppMenVec = new Vector();
				if (theGame.getTurn()==Box.RED){ 
					oppMen = theGame.getBlueMen();
					oppMenVec = theGame.getSquaresVec(Box.RED);
				}
				else{
					oppMen = theGame.getRedMen();
					oppMenVec = theGame.getSquaresVec(Box.BLUE);
				}
				float tot = oppMen+playerMen;
				float pmFloat = playerMen;
				float result = pmFloat/tot;
			//	System.out.println("playerMen = "+playerMen+", oppMen = "+oppMen+", playerMen/(oppMen+playerMen) = "+result);
				RiskGameMove curMove = theGame.getPlayer(theGame.getTurn()).generateMove(result,theGame.getGrid(), new Vector(oppMenVec));
				theGame.setToBox(curMove.getToBox());
				theGame.setFromBox(curMove.getFromBox());
				if (!CustomPanelTest.getRefreshView()){
					if (theGame.getGrid().getBox(curMove.getToBox()).getCol()==theGame.getTurn()) CustomPanelTest.addToAlreadyOccSqs(theGame.getTurn());
					else if (theGame.getGrid().getBox(curMove.getToBox()).getCol()==Box.EMPTY) CustomPanelTest.addToEmptySqs(theGame.getTurn());
				}
				Long aLong = new Long(theGame.getGrid().getBox(theGame.getFromBox()).getNum(theGame.getTurn())-curMove.getNoMen());
				if (aLong.intValue()<=0) theGame.getPlayer(theGame.getTurn()).removeSquare(theGame.getGrid().getBox(theGame.getFromBox()).getBoxPosition());
				theGame.getGrid().getBox(theGame.getFromBox()).setNum(theGame.getTurn(),aLong.intValue());
				aLong = new Long(theGame.getGrid().getBox(theGame.getToBox()).getNum(theGame.getTurn())+curMove.getNoMen()); 
				if (aLong.intValue()-curMove.getNoMen()==0) theGame.getPlayer(theGame.getTurn()).addSquare(theGame.getGrid().getBox(theGame.getToBox())); 
				theGame.getGrid().getBox(theGame.getToBox()).setNum(theGame.getTurn(),aLong.intValue());
				theGame.tidyBox(theGame.getFromBox());
				theGame.tidyBox(theGame.getToBox());
				//System.out.println("fromBox = "+ theGame.getFromBox().getHoriz()+", "+theGame.getFromBox().getVert()+".");
				//System.out.println("noMen = "+curMove.getNoMen());
				//System.out.println("toBox = "+ theGame.getToBox().getHoriz()+", "+theGame.getToBox().getVert()+"."); 
				if (theGame.getGrid().getBox(theGame.getToBox()).getCol()==Box.BOTH){
					if (!CustomPanelTest.getRefreshView()){
						 CustomPanelTest.addMenCommitted(theGame.getTurn(),curMove.getNoMen());
						 CustomPanelTest.addBattleInit(theGame.getTurn());
					}
					theGame.setBattleInProgress(true);
					theGame.setBattleBox(theGame.getToBox());
					startBattle();
				}
				else finishedBattle();
				if (theGame!=null){
					myPanel.repaint();
					CustomPanelTest.updateInfoBar();
				}
			}
			else{
				theGame.setGameFinished();
				if (theGame.getGameFinished()){
					CustomPanelTest.finishedGame();	
					myPanel.setGame(null);
					myPanel.setVisible(false);
					myPanel=new CustomPanel();
					myPanel.setVisible(true);
					theGame=null;
					myPanel.repaint();
					CustomPanelTest.resetPanel();
				}
			}
		}
	}
	private void startBattle(){
		Box battleBox = theGame.getGrid().getBox(theGame.getBattleBox());
		long scoreMax = theGame.getScoreMax(battleBox);
		long redScore = Math.round(Math.random()*scoreMax);
		long blueScore = Math.round(Math.random()*scoreMax);
		if (theGame.getWeighted()){
			redScore = redScore*battleBox.getRedNum();
			blueScore = blueScore*battleBox.getBlueNum();
		}
		if (redScore==blueScore && theGame.getDraws()==RiskGame.REROLLED){
			while (redScore==blueScore){
				redScore = Math.round(Math.random()*scoreMax);
				blueScore = Math.round(Math.random()*scoreMax);
				if (theGame.getWeighted()){
					redScore = redScore*battleBox.getRedNum();
					blueScore = blueScore*battleBox.getBlueNum();
				}
			}
		}
		if (theGame.getScoreResultStatus()==RiskGame.BATTLE){
			if (redScore>blueScore ||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS && theGame.getGameState()==RiskGame.IN_GAME)||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS)){
				CustomPanelTest.addMenLost(Box.BLUE, battleBox.getBlueNum());
				battleBox.setBlueNum(0);
				theGame.setLastWinner(Box.RED);
			}
			else if (redScore<blueScore ||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS)||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS && theGame.getGameState()==RiskGame.IN_GAME)){
				CustomPanelTest.addMenLost(Box.RED, battleBox.getRedNum());
				battleBox.setRedNum(0);
				theGame.setLastWinner(Box.BLUE);
			}
			finishedBattle();
		}
		else if (theGame.getScoreResultStatus()==RiskGame.ONE_MAN){
			if (redScore>blueScore ||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS && theGame.getGameState()==RiskGame.IN_GAME)||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS)){
				battleBox.setBlueNum(battleBox.getBlueNum()-1);
				CustomPanelTest.addMenLost(Box.BLUE, 1);
				theGame.setLastWinner(Box.RED);
			}
			else if (redScore<blueScore ||(theGame.getTurn()==Box.BLUE && redScore==blueScore && theGame.getDraws()==RiskGame.ATTACKER_WINS)||(theGame.getTurn()==Box.RED && redScore==blueScore && theGame.getDraws()==RiskGame.DEFENDER_WINS && theGame.getGameState()==RiskGame.IN_GAME)){
				battleBox.setRedNum(battleBox.getRedNum()-1);
				CustomPanelTest.addMenLost(Box.RED, 1);
				theGame.setLastWinner(Box.BLUE);
			}
			if (battleBox.getRedNum()==0 || battleBox.getBlueNum()==0){
				if (!CustomPanelTest.getRefreshView()){
					if (battleBox.getRedNum()==0) CustomPanelTest.addBattleWon(Box.BLUE);
					else if (battleBox.getBlueNum()==0) CustomPanelTest.addBattleWon(Box.RED);
				}
				finishedBattle();
			}
		}
		if (theGame!=null){
			CustomPanelTest.updateInfoBar();
			theGame.setLastRedScore(redScore);
			theGame.setLastBlueScore(blueScore);
			if (theGame.getBattleBox()!=null){
				battleBox = theGame.getGrid().getBox(theGame.getBattleBox());
				if (theGame.getAttackerWithdraw()){
					if ((!theGame.getPlayer(theGame.getTurn()).equals("HUMAN")) && theGame.getPlayer(theGame.getTurn()).getShouldWithdraw(battleBox.getRedNum(),battleBox.getBlueNum())){
						theGame.setAttWDing(true);
						myPanel.doWithdraw(theGame.getPlayer(theGame.getTurn()).getWithdraw(theGame.getWithdraws(battleBox,theGame.getTurn())));
						if (myPanel.getRetreatAllowed()){
							if ((theGame.getTurn()==Box.RED) && (!CustomPanelTest.getRefreshView())) CustomPanelTest.addBattleWon(Box.BLUE);
							if ((theGame.getTurn()==Box.BLUE) && (!CustomPanelTest.getRefreshView())) CustomPanelTest.addBattleWon(Box.RED);
							if (!CustomPanelTest.getRefreshView()) CustomPanelTest.addAttackingWD(theGame.getTurn());
							finishedBattle();
						//	System.out.println("ATTACKING WITHDRAW");
						}
					}
				}	
				if (theGame!=null){
					if (theGame.getBattleBox()!=null){
						battleBox = theGame.getGrid().getBox(theGame.getBattleBox());
						if (theGame.getDefenderWithdraw()){
							if ((!theGame.getPlayer(Box.RED).equals("HUMAN")) && theGame.getTurn()==Box.BLUE && theGame.getPlayer(Box.RED).getShouldWithdraw(battleBox.getRedNum(),battleBox.getBlueNum())){
								theGame.setDefWDing(true);
								myPanel.doWithdraw(theGame.getPlayer(Box.RED).getWithdraw(theGame.getWithdraws(battleBox,Box.RED)));
								if (myPanel.getRetreatAllowed()){
									if (!CustomPanelTest.getRefreshView()){
										 CustomPanelTest.addBattleWon(Box.BLUE);
										 CustomPanelTest.addDefensiveWD(Box.RED);
									}
								//	System.out.println("RED DEFENSIVE WITHDRAW");
									finishedBattle();
								}
							}
							else if (theGame!=null){
								if ((!theGame.getPlayer(Box.BLUE).equals("HUMAN")) && theGame.getTurn()==Box.RED && theGame.getPlayer(Box.BLUE).getShouldWithdraw(battleBox.getRedNum(),battleBox.getBlueNum())){
									theGame.setDefWDing(true);
									myPanel.doWithdraw(theGame.getPlayer(Box.BLUE).getWithdraw(theGame.getWithdraws(battleBox,Box.BLUE)));	
									if (myPanel.getRetreatAllowed()){
										if (!CustomPanelTest.getRefreshView()){
											 CustomPanelTest.addBattleWon(Box.RED);
											 CustomPanelTest.addDefensiveWD(Box.BLUE);
										}
								 	//	System.out.println("BLUE DEFENSIVE WITHDRAW");
								 		finishedBattle();
								 	}
								}
							}	
						}
					}	
				}
			}
		}
	}

	public void finishedBattle(){
		if (theGame.getBattleBox()!=null){
			if (theGame.getGrid().getBox(theGame.getBattleBox()).getRedNum()<=0)
				theGame.getRedPlayer().removeSquare(theGame.getBattleBox());
			if (theGame.getGrid().getBox(theGame.getBattleBox()).getBlueNum()<=0)
				theGame.getBluePlayer().removeSquare(theGame.getBattleBox());
		}
		if (theGame.getFromBox()!=null)theGame.tidyBox(theGame.getFromBox());
		if (theGame.getToBox()!=null)theGame.tidyBox(theGame.getToBox());
		if (theGame.getCurBox()!=null)theGame.tidyBox(theGame.getCurBox());
		theGame.setCurBox(null);
		theGame.setFromBox(null);
		theGame.setToBox(null);
		theGame.setBattleBox(null);
		theGame.decrementMovesLeft();
		if (CustomPanelTest.getRefreshView()){
			CustomPanelTest.setColour();
			CustomPanelTest.updateInfoBar();
			myPanel.repaint();
		}
		if (theGame.getMovesLeft()==0){
			theGame.resetMovesLeft();
			theGame.swapTurns();
		}
		if (CustomPanelTest.getRefreshView())CustomPanelTest.setColour();
		if (theGame.getRedPlayer().getNoOccupiedSquares()==0 || theGame.getBluePlayer().getNoOccupiedSquares()==0){
			theGame.setGameFinished();
		}
		if (theGame.getGameFinished()){
			CustomPanelTest.finishedGame();	
			myPanel.setGame(null);
			myPanel.setVisible(false);
			myPanel=new CustomPanel();
			myPanel.setVisible(true);
			theGame=null;
			myPanel.repaint();
			CustomPanelTest.resetPanel();
		}
	}	
}