//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: PositionReader
// Version: 1.0
// Last Modified: 17/02/2004
//----------------------------------------------------------------
import java.io.*;
import java.util.*;

public class PositionReader{	
	Enumeration posNMen;
	RiskGame rg;
	public PositionReader(File posFile, RiskGame rgPar) throws IOException{
		Vector myTokens = new Vector();
		Vector myPos = new Vector();
		BufferedReader stream = new BufferedReader(new InputStreamReader(
			new FileInputStream(posFile)));
		rg = rgPar;
		while (stream.ready()){
			String curStr = stream.readLine();
			StringTokenizer st = new StringTokenizer(curStr, "<>");
			while (st.hasMoreTokens()){
				myTokens.addElement(st.nextToken());
			}
		}
		posNMen = myTokens.elements();
		try{
			setRedSquares();
			setBlueSquares();
		/*	setRedMen();
			setBlueMen();*/
		}
		catch (Exception e){System.out.println(e.getMessage());}
	}
	public void setRedSquares(){
		String curToken = (String)posNMen.nextElement();
		Vector posTokens = new Vector();
		while (posNMen.hasMoreElements() && !curToken.equals("RED_SQUARES")){
			curToken = (String)posNMen.nextElement();
		}
		if (curToken.equals("RED_SQUARES")){
			curToken = (String)posNMen.nextElement();
			while(!curToken.equals("/RED_SQUARES")){
				StringTokenizer st = new StringTokenizer(curToken,",");
				while (st.hasMoreTokens()){
					posTokens.addElement(st.nextToken());
				}
				int xCoord = Integer.parseInt((String)posTokens.elementAt(0));
				int yCoord = Integer.parseInt((String)posTokens.elementAt(1));
				long noMen = Long.parseLong((String)posTokens.elementAt(2));
			//	System.out.println("Red Square with coordS X = "+xCoord+", Y = "+yCoord);
				
				if (rg.getSquareAllocStatus()==RiskGame.FROM_FILE){
					rg.setSquare(xCoord, yCoord, Box.RED);
					if (rg.getManAllocStatus()==RiskGame.FROM_FILE){
						rg.getGrid().getBox(xCoord,yCoord).setRedNum(noMen);	
					}
					rg.getRedPlayer().addSquare(rg.getGrid().getBox(xCoord,yCoord));
				}
				else if (rg.getManAllocStatus()==RiskGame.FROM_FILE){
					boolean boxFound=false;
					for (int i=0; (i<rg.getGridX() && !boxFound); i++){
						for (int j=0; (j<rg.getGridY() && !boxFound); j++){
							if (rg.getGrid().getBox(i,j).getRedNum()==0 && (rg.getGrid().getBox(i,j).getCol()==Box.RED || rg.getGrid().getBox(i,j).getCol()==Box.BOTH)){
								//rg.getGrid().getBox(i,j).setRedNum(noMen);
								rg.getGrid().getBox(i,j).setRedNum(noMen);
								boxFound=true;
							}
						}
					}	
				}	
				curToken = (String)posNMen.nextElement();
				posTokens = new Vector();
			}
		}
	}
	public void setBlueSquares(){
		String curToken = (String)posNMen.nextElement();
		Vector posTokens = new Vector();
		while (posNMen.hasMoreElements() && !curToken.equals("BLUE_SQUARES")){
			curToken = (String)posNMen.nextElement();
		}
		if (curToken.equals("BLUE_SQUARES")){
			curToken = (String)posNMen.nextElement();
			while(!curToken.equals("/BLUE_SQUARES")){
				StringTokenizer st = new StringTokenizer(curToken,",");
				while (st.hasMoreTokens()){
					posTokens.addElement(st.nextToken());
				}
				int xCoord = Integer.parseInt((String)posTokens.elementAt(0));
				int yCoord = Integer.parseInt((String)posTokens.elementAt(1));
				long noMen = Long.parseLong((String)posTokens.elementAt(2));
			//	System.out.println("Blue Square with coordS X = "+xCoord+", Y = "+yCoord);
				if (rg.getSquareAllocStatus()==RiskGame.FROM_FILE){
					rg.setSquare(xCoord, yCoord, Box.BLUE);
					if (rg.getManAllocStatus()==RiskGame.FROM_FILE){
						rg.getGrid().getBox(xCoord,yCoord).setBlueNum(noMen);	
					}
					rg.getBluePlayer().addSquare(rg.getGrid().getBox(xCoord,yCoord));
				}
				else if (rg.getManAllocStatus()==RiskGame.FROM_FILE){
					boolean boxFound=false;
					for (int i=0; (i<rg.getGridX() && !boxFound); i++){
						for (int j=0; (j<rg.getGridY() && !boxFound); j++){
							if (rg.getGrid().getBox(i,j).getBlueNum()==0 && (rg.getGrid().getBox(i,j).getCol()==Box.BLUE || rg.getGrid().getBox(i,j).getCol()==Box.BOTH)){
						//		rg.getGrid().getBox(i,j).setBlueNum(noMen);
								rg.getGrid().getBox(i,j).setBlueNum(noMen);
								boxFound=true;
							}
						}
					}	
				}	
				curToken = (String)posNMen.nextElement();
				posTokens = new Vector();
			}
		}
	}
/*	public void setRedMen(){
		String curToken = (String)posNMen.nextElement();
		while (posNMen.hasMoreElements() && !curToken.equals("RED_MEN")){
			curToken = (String)posNMen.nextElement();
		}
		if (curToken.equals("RED_MEN")){
			curToken = (String)posNMen.nextElement();
			int i=0;
			while(!curToken.equals("/RED_MEN")){
				int men = Integer.parseInt(curToken);
				BoxPosition bp = rg.getRedPlayer().getBoxPosition(i);
				rg.getGrid().getBox(bp.getHoriz(), bp.getVert()).setRedNum(men);
				curToken = (String)posNMen.nextElement();
				i++;
			}
		}
	}
	public void setBlueMen(){
		String curToken = (String)posNMen.nextElement();
		while (posNMen.hasMoreElements() && !curToken.equals("BLUE_MEN")){
			curToken = (String)posNMen.nextElement();
		}
		if (curToken.equals("BLUE_MEN")){
			curToken = (String)posNMen.nextElement();
			int i=0;
			while(!curToken.equals("/BLUE_MEN")){
				int men = Integer.parseInt(curToken);
				BoxPosition bp = rg.getBluePlayer().getBoxPosition(i);
				rg.getGrid().getBox(bp.getHoriz(), bp.getVert()).setBlueNum(men);
				curToken = (String)posNMen.nextElement();
				i++;
			}
		}
	}	*/			
	
	public static void main(String[] argv) throws IOException{
	//	PositionReader pr = new PositionReader(new File("game1.pos")); 
		//System.out.println(theGame.getGameText());
	}
}