//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: ReinforcementPlayerReader
// Version: 1.0
// Last Modified: 05/04/2004
//----------------------------------------------------------------
import java.io.*;
import java.util.*;

public class ReinforcementPlayerReader{
	int totGP = 0;
	int gp=0;
	int gamesPlayed=0;
	float significance = 0;
	float attDec = 0;
	boolean rankSig = false, firstIt=true;
	float minAtt = 0;
	float maxAtt = 0;
	String typeNumMen = new String("RANDOM");
	float reinforceRatio = 0;
	float attEmp = 0;
	float defEmp = 0;
public ReinforcementPlayerReader(String theFileStr){
	File aiPlayerFile = new File(theFileStr);
	Vector myTokens = new Vector();
	try{
		BufferedReader stream = new BufferedReader(new InputStreamReader(new FileInputStream(aiPlayerFile)));
		while (stream.ready()){
			String curStr = stream.readLine();
			StringTokenizer st = new StringTokenizer(curStr, ";");
			while (st.hasMoreTokens()){
				myTokens.addElement(st.nextToken());
			}
		}
		stream.close();
	}
	catch(Exception e){}
	Enumeration rules = myTokens.elements();
	try{
		while (rules.hasMoreElements()){
			setGamesPlayed((String)rules.nextElement());
			if (firstIt){
				setInsignificant((String)rules.nextElement());
				setRankSignificance((String)rules.nextElement());
				setAttackDecimal((String)rules.nextElement());
				setMinimumAttack((String)rules.nextElement());
				setMaximumAttack((String)rules.nextElement());
				setTypeNumMen((String)rules.nextElement());
				setReinforceRatio((String)rules.nextElement());
				setAttackEmpty((String)rules.nextElement());
				setDefendEmpty((String)rules.nextElement());
	//			setAttackTracking((String)rules.nextElement());
				firstIt=false;
			}
			else for (int i=0; i<9; i++) rules.nextElement();
		}	
		printHeuristics();
	}
	catch (Exception e){System.out.println(e.getMessage());}	
} 
private void setGamesPlayed(String gamesPlayPar){
	gp =  (new Integer((String)gamesPlayPar.substring(13))).intValue();
	totGP += gp;
}
public int getGamesPlayed(){
	return totGP;
}
private void setInsignificant(String insigPar){
	float curSig = (new Float((String)insigPar.substring(14))).floatValue();
	significance = (significance*(totGP-gp)+curSig*gp)/totGP;
}
public float getInsignificant(){
	return significance;
} 
private void setRankSignificance(String rankSigPar){
	if (rankSigPar.substring(18).equals("TRUE")) rankSig=true;
	else rankSig=false;	
}
public String getRankSignificanceStr(){
	if (rankSig==true) return "TRUE";
	return "FALSE";
}
public boolean getRankSignificance(){
	return rankSig;
}
private void setAttackDecimal(String adPar){
	float curAttDec = (new Float((String)adPar.substring(15))).floatValue();
	attDec = (attDec*(totGP-gp)+curAttDec*gp)/totGP;
}
public float getAttackDecimal(){
	return attDec;
}
private void setMinimumAttack(String minAttPar){
	float curMinAtt = (new Float((String)minAttPar.substring(15))).floatValue();
	minAtt = (minAtt*(totGP-gp)+curMinAtt*gp)/totGP;
}
public float getMinimumAttack(){
	return minAtt;
}
private void setMaximumAttack(String maxAttPar){
	float curMaxAtt = (new Float((String)maxAttPar.substring(15))).floatValue();
	maxAtt = (maxAtt*(totGP-gp)+curMaxAtt*gp)/totGP;
}
public float getMaximumAttack(){
	return maxAtt;
}
private void setTypeNumMen(String typeNumMenPar){
	typeNumMen = typeNumMenPar.substring(13);
}
public String getTypeNumMen(){
	return typeNumMen;
}
private void setReinforceRatio(String rrPar){
	float curRR = (new Float((String)rrPar.substring(16))).floatValue();
	reinforceRatio = (reinforceRatio*(totGP-gp)+curRR*gp)/totGP;
}
public float getReinforceRatio(){
	return reinforceRatio;
}
private void setAttackEmpty(String aePar){
	float curAttEmp = (new Float((String)aePar.substring(13))).floatValue();
	attEmp = (attEmp*(totGP-gp)+curAttEmp*gp)/totGP;
}
public float getAttackEmpty(){
	return attEmp;
}
private void setDefendEmpty(String dePar){
	float curDefEmp = (new Float((String)dePar.substring(13))).floatValue();
	defEmp = (defEmp*(totGP-gp)+curDefEmp*gp)/totGP;
}
public float getDefendEmpty(){
	return defEmp;
}
/*private void setAttackTracking(String atPar){
	if (((String)atPar.substring(16)).equals("TRUE")) thePlayer.setAttackTracking(true);
	else thePlayer.setAttackTracking(false);
	System.out.println("ATTACK_TRACKING "+thePlayer.getAttackTracking()+";");
}*/
private void printHeuristics(){
	System.out.println("INSIGNIFICANT "+significance+";");
	System.out.println("RANK_SIGNIFICANCE "+rankSig+";");
	System.out.println("ATTACK_DECIMAL "+attDec+";");
	System.out.println("MINIMUM_ATTACK "+minAtt+";");
	System.out.println("MAXIMUM_ATTACK "+maxAtt+";");
	System.out.println("TYPE_NUM_MEN "+typeNumMen+";");
	System.out.println("REINFORCE_RATIO "+reinforceRatio+";");
	System.out.println("ATTACK_EMPTY "+attEmp+";");
	System.out.println("DEFEND_EMPTY "+defEmp+";");
}
public static void main(String[] args){
	ReinforcementPlayerReader rpr = new ReinforcementPlayerReader((String)args[0]);
}
}