//----------------------------------------------------------------
// "A Game of Intelligent Risk" by David Russell Newman (drn101) 
// Class: TournamentReader
// Version: 1.0
// Last Modified: 04/04/2004
//----------------------------------------------------------------
import java.io.*;
import java.util.*;

public class TournamentReader{
	Vector matches;

public TournamentReader(String theFileStr){
	File tournFile = new File(theFileStr);
	Vector myTokens = new Vector();
	boolean HAndA = false;
	boolean firstPV = false; 
	matches = new Vector();
	try{
	BufferedReader stream = new BufferedReader(new InputStreamReader(new FileInputStream(tournFile)));
	while (stream.ready()){
		String curStr = stream.readLine();
		StringTokenizer st = new StringTokenizer(curStr, ";");
		while (st.hasMoreTokens()){
			myTokens.addElement(st.nextToken());
		}
	}
	}catch(Exception e){}
	try{
		if (((String)myTokens.remove(0)).substring(13).equals("TRUE")) HAndA=true;
		if (((String)myTokens.remove(0)).substring(20).equals("TRUE")) firstPV=true;
		if (firstPV){
			String firstPlayer = (String)myTokens.remove(0);
			for (int i=0; i<myTokens.size(); i++){
				matches.add(new RiskGameMatch(firstPlayer,(String)myTokens.get(i)));
				if (HAndA) matches.add(new RiskGameMatch((String)myTokens.get(i),firstPlayer));	
			}
		}
		else{
			for (int i=0; i<myTokens.size(); i++){
				for (int j=0; j<myTokens.size(); j++){
					if (!HAndA && i>j) matches.add(new RiskGameMatch((String)myTokens.get(i), (String)myTokens.get(j)));
					else if(HAndA && i!=j) matches.add(new RiskGameMatch((String)myTokens.get(i), (String)myTokens.get(j)));
				}
			}	
		}
		System.out.println("Finished");
	}
	catch (Exception e){System.out.println(e.getMessage());}	
} 

public Vector getMatches(){
	return matches;
}
public void printMatches(){
	System.out.println("Num of matches "+matches.size());
	for (int i=0; i<matches.size(); i++){
		RiskGameMatch curMatch = (RiskGameMatch)matches.get(i);
		System.out.println(curMatch.getRedPlayer()+" v "+curMatch.getBluePlayer());
	}
}
public static void main(String[] argv){
	TournamentReader tr = new TournamentReader("tourn2.trn");
	tr.printMatches();
}
}